/*
 *	 /usr/devel/src/libfuture/libfuture.cpp
 *	 Generated by sql2class v1.9.1 by (C) AH 2000-2006
 *	  using command line
 *	  $ sql2class -build -lib libfuture -sqlite str-future -namespace db -overwrite -getset
 *	 Date: Thu Sep 28 00:25:14 2006
 */

/*
Copyright (C) 2001-2006  Anders Hedstrom (grymse@alhem.net)

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/
#include <libfuture.h>

namespace db {

/**
 **  Begin class 'Account'
 **/

Account::Account(Database *db)
{
	database = db;
	new_object = 1;
	clear();
}


Account::Account(Database *db,const std::string& sql)
{
	database = db;
	new_object = 1;
	spawn(sql);
}


Account::Account(Database *db,Query *qd,int offset)
{
	database = db;
	new_object = 0;
	spawn(qd, offset);
}


Account::Account(Database& db,long i_num):database(&db),new_object(1)
{
	Query q(*database);
	std::string sql = "select * from account where ";
	{
		char slask[100];
		sprintf(slask,"num='%ld'",i_num);
		sql += slask;
	}
	spawn(sql);
}


Account::Account(Database& db,const std::string&  i_name):database(&db),new_object(1)
{
	Query q(*database);
	std::string sql = "select * from account where ";
	sql += "name='" + q.GetDatabase().safestr(i_name) + "'";
	spawn(sql);
}


Account::~Account()
{
}


void Account::select(const std::string& sql)
{
	spawn(sql);
}


unsigned long long int Account::insert()
{
	Query q(*database);
	std::string sql;

	sql = "insert into account(name,passwd,display_name,wizard,email,area,chunk,chunkx,chunky,facing,wizview,race)";
	sql += " values('" + q.GetDatabase().safestr(this -> name) + "'";
	sql += ", '" + q.GetDatabase().safestr(this -> passwd) + "'";
	sql += ", '" + q.GetDatabase().safestr(this -> display_name) + "'";
	{
		char slask[100];
		sprintf(slask,", %d",this -> wizard);
		sql += slask;
	}
	sql += ", '" + q.GetDatabase().safestr(this -> email) + "'";
	{
		char slask[100];
		sprintf(slask,", %ld",this -> area);
		sql += slask;
	}
	{
		char slask[100];
		sprintf(slask,", %ld",this -> chunk);
		sql += slask;
	}
	{
		char slask[100];
		sprintf(slask,", %ld",this -> chunkx);
		sql += slask;
	}
	{
		char slask[100];
		sprintf(slask,", %ld",this -> chunky);
		sql += slask;
	}
	{
		char slask[100];
		sprintf(slask,", %ld",this -> facing);
		sql += slask;
	}
	{
		char slask[100];
		sprintf(slask,", %ld",this -> wizview);
		sql += slask;
	}
	{
		char slask[100];
		sprintf(slask,", %ld",this -> race);
		sql += slask;
	}
	sql += ")";
	q.execute(sql);
	new_object = 0;
	unsigned long long int inserted_id = q.insert_id();
	num = inserted_id;
	return inserted_id;
}


void Account::update()
{
	update(this -> num);
}


void Account::update(long i_num)
{
	Query q(*database);
	std::string sql;
	sql += "update account set name='" + q.GetDatabase().safestr(this -> name) + "'";
	sql += ", passwd='" + q.GetDatabase().safestr(this -> passwd) + "'";
	sql += ", display_name='" + q.GetDatabase().safestr(this -> display_name) + "'";
	{
		char slask[200];
		sprintf(slask,", wizard=%d",this -> wizard);
		sql += slask;
	}
	sql += ", email='" + q.GetDatabase().safestr(this -> email) + "'";
	{
		char slask[200];
		sprintf(slask,", area=%ld",this -> area);
		sql += slask;
	}
	{
		char slask[200];
		sprintf(slask,", chunk=%ld",this -> chunk);
		sql += slask;
	}
	{
		char slask[200];
		sprintf(slask,", chunkx=%ld",this -> chunkx);
		sql += slask;
	}
	{
		char slask[200];
		sprintf(slask,", chunky=%ld",this -> chunky);
		sql += slask;
	}
	{
		char slask[200];
		sprintf(slask,", facing=%ld",this -> facing);
		sql += slask;
	}
	{
		char slask[200];
		sprintf(slask,", wizview=%ld",this -> wizview);
		sql += slask;
	}
	{
		char slask[200];
		sprintf(slask,", race=%ld",this -> race);
		sql += slask;
	}
	{
		char slask[200];
		sprintf(slask," where num='%ld'",i_num);
		sql += slask;
	}
	q.execute(sql);
}


void Account::save()
{
	if (new_object)
		insert();
	else
		update();
}


void Account::erase()
{
	if (!new_object)
	{
		std::string sql = "delete from account where";
		Query q(*database);
		{
			char slask[200];
			sprintf(slask," num='%ld'",this -> num);
			sql += slask;
		}
		q.execute(sql);
	}
}


std::string Account::xml()
{
	Query q(*database);
	std::string dest;
	char slask[200];
	dest = "<ACCOUNT>";
	sprintf(slask,"<NUM>%ld</NUM>",this -> num);
	dest += slask;
	dest += "<NAME>" + q.GetDatabase().xmlsafestr(this -> name) + "</NAME>";
	dest += "<PASSWD>" + q.GetDatabase().xmlsafestr(this -> passwd) + "</PASSWD>";
	dest += "<DISPLAY_NAME>" + q.GetDatabase().xmlsafestr(this -> display_name) + "</DISPLAY_NAME>";
	sprintf(slask,"<WIZARD>%d</WIZARD>",this -> wizard);
	dest += slask;
	dest += "<EMAIL>" + q.GetDatabase().xmlsafestr(this -> email) + "</EMAIL>";
	sprintf(slask,"<AREA>%ld</AREA>",this -> area);
	dest += slask;
	sprintf(slask,"<CHUNK>%ld</CHUNK>",this -> chunk);
	dest += slask;
	sprintf(slask,"<CHUNKX>%ld</CHUNKX>",this -> chunkx);
	dest += slask;
	sprintf(slask,"<CHUNKY>%ld</CHUNKY>",this -> chunky);
	dest += slask;
	sprintf(slask,"<FACING>%ld</FACING>",this -> facing);
	dest += slask;
	sprintf(slask,"<WIZVIEW>%ld</WIZVIEW>",this -> wizview);
	dest += slask;
	sprintf(slask,"<RACE>%ld</RACE>",this -> race);
	dest += slask;
	dest += "</ACCOUNT>";
	return dest;
}


std::string Account::xml(const std::string& tag,const std::string& xvalx)
{
	Query q(*database);
	std::string dest;
	char slask[200];
	dest = "<ACCOUNT " + tag + "=\"" + xvalx + "\">";
	sprintf(slask,"<NUM>%ld</NUM>",this -> num);
	dest += slask;
	dest += "<NAME>" + q.GetDatabase().xmlsafestr(this -> name) + "</NAME>";
	dest += "<PASSWD>" + q.GetDatabase().xmlsafestr(this -> passwd) + "</PASSWD>";
	dest += "<DISPLAY_NAME>" + q.GetDatabase().xmlsafestr(this -> display_name) + "</DISPLAY_NAME>";
	sprintf(slask,"<WIZARD>%d</WIZARD>",this -> wizard);
	dest += slask;
	dest += "<EMAIL>" + q.GetDatabase().xmlsafestr(this -> email) + "</EMAIL>";
	sprintf(slask,"<AREA>%ld</AREA>",this -> area);
	dest += slask;
	sprintf(slask,"<CHUNK>%ld</CHUNK>",this -> chunk);
	dest += slask;
	sprintf(slask,"<CHUNKX>%ld</CHUNKX>",this -> chunkx);
	dest += slask;
	sprintf(slask,"<CHUNKY>%ld</CHUNKY>",this -> chunky);
	dest += slask;
	sprintf(slask,"<FACING>%ld</FACING>",this -> facing);
	dest += slask;
	sprintf(slask,"<WIZVIEW>%ld</WIZVIEW>",this -> wizview);
	dest += slask;
	sprintf(slask,"<RACE>%ld</RACE>",this -> race);
	dest += slask;
	dest += "</ACCOUNT>";
	return dest;
}


size_t Account::num_cols()
{
	return 13;
}


void Account::clear()
{
	this -> num = 0;
	this -> name = "";
	this -> passwd = "";
	this -> display_name = "";
	this -> wizard = 0;
	this -> email = "";
	this -> area = 0;
	this -> chunk = 0;
	this -> chunkx = 0;
	this -> chunky = 0;
	this -> facing = 0;
	this -> wizview = 0;
	this -> race = 0;
}


void Account::spawn(const std::string& sql)
{
	Query q(*database);
	std::string temp;

	clear();

	if (!strncasecmp(sql.c_str(),"select * ",9))
	{
		temp = "select num,name,passwd,display_name,wizard,email,area,chunk,chunkx,chunky,facing,wizview,race " + sql.substr(9);
	} else
		temp = sql;
	q.get_result(temp);
	if (q.fetch_row())
	{
		this -> num = q.getval(0);																				// 0 - num integer
		this -> name = q.getstr(1);																				// 1 - name varchar(255)
		this -> passwd = q.getstr(2);																				// 2 - passwd varchar(255)
		this -> display_name = q.getstr(3);																				// 3 - display_name varchar(255)
		this -> wizard = q.getval(4);																				// 4 - wizard tinyint(1)
		this -> email = q.getstr(5);																				// 5 - email varchar(255)
		this -> area = q.getval(6);																				// 6 - area integer
		this -> chunk = q.getval(7);																				// 7 - chunk integer
		this -> chunkx = q.getval(8);																				// 8 - chunkx integer
		this -> chunky = q.getval(9);																				// 9 - chunky integer
		this -> facing = q.getval(10);																				// 10 - facing integer
		this -> wizview = q.getval(11);																				// 11 - wizview integer
		this -> race = q.getval(12);																				// 12 - race integer
		new_object = 0;
	} else
		clear();
	q.free_result();
}


void Account::spawn(Query *qd,int offset)
{
	clear();

	this -> num = qd -> getval(0 + offset);																				// 0 - num integer
	this -> name = qd -> getstr(1 + offset);																				// 1 - name varchar(255)
	this -> passwd = qd -> getstr(2 + offset);																				// 2 - passwd varchar(255)
	this -> display_name = qd -> getstr(3 + offset);																				// 3 - display_name varchar(255)
	this -> wizard = qd -> getval(4 + offset);																				// 4 - wizard tinyint(1)
	this -> email = qd -> getstr(5 + offset);																				// 5 - email varchar(255)
	this -> area = qd -> getval(6 + offset);																				// 6 - area integer
	this -> chunk = qd -> getval(7 + offset);																				// 7 - chunk integer
	this -> chunkx = qd -> getval(8 + offset);																				// 8 - chunkx integer
	this -> chunky = qd -> getval(9 + offset);																				// 9 - chunky integer
	this -> facing = qd -> getval(10 + offset);																				// 10 - facing integer
	this -> wizview = qd -> getval(11 + offset);																				// 11 - wizview integer
	this -> race = qd -> getval(12 + offset);																				// 12 - race integer
}


// End of implementation of class 'Account'

} // End of namespace
namespace db {

/**
 **  Begin class 'Eventcount'
 **/

Eventcount::Eventcount(Database *db)
{
	database = db;
	new_object = 1;
	clear();
}


Eventcount::Eventcount(Database *db,const std::string& sql)
{
	database = db;
	new_object = 1;
	spawn(sql);
}


Eventcount::Eventcount(Database *db,Query *qd,int offset)
{
	database = db;
	new_object = 0;
	spawn(qd, offset);
}


Eventcount::Eventcount(Database& db,long i_num):database(&db),new_object(1)
{
	Query q(*database);
	std::string sql = "select * from eventcount where ";
	{
		char slask[100];
		sprintf(slask,"num='%ld'",i_num);
		sql += slask;
	}
	spawn(sql);
}


Eventcount::Eventcount(Database& db,const std::string&  i_event_name):database(&db),new_object(1)
{
	Query q(*database);
	std::string sql = "select * from eventcount where ";
	sql += "event_name='" + q.GetDatabase().safestr(i_event_name) + "'";
	spawn(sql);
}


Eventcount::~Eventcount()
{
}


void Eventcount::select(const std::string& sql)
{
	spawn(sql);
}


unsigned long long int Eventcount::insert()
{
	Query q(*database);
	std::string sql;

	sql = "insert into eventcount(event_name,count)";
	sql += " values('" + q.GetDatabase().safestr(this -> event_name) + "'";
	{
		char slask[100];
		sprintf(slask,", %ld",this -> count);
		sql += slask;
	}
	sql += ")";
	q.execute(sql);
	new_object = 0;
	unsigned long long int inserted_id = q.insert_id();
	num = inserted_id;
	return inserted_id;
}


void Eventcount::update()
{
	update(this -> num);
}


void Eventcount::update(long i_num)
{
	Query q(*database);
	std::string sql;
	sql += "update eventcount set event_name='" + q.GetDatabase().safestr(this -> event_name) + "'";
	{
		char slask[200];
		sprintf(slask,", count=%ld",this -> count);
		sql += slask;
	}
	{
		char slask[200];
		sprintf(slask," where num='%ld'",i_num);
		sql += slask;
	}
	q.execute(sql);
}


void Eventcount::save()
{
	if (new_object)
		insert();
	else
		update();
}


void Eventcount::erase()
{
	if (!new_object)
	{
		std::string sql = "delete from eventcount where";
		Query q(*database);
		{
			char slask[200];
			sprintf(slask," num='%ld'",this -> num);
			sql += slask;
		}
		q.execute(sql);
	}
}


std::string Eventcount::xml()
{
	Query q(*database);
	std::string dest;
	char slask[200];
	dest = "<EVENTCOUNT>";
	sprintf(slask,"<NUM>%ld</NUM>",this -> num);
	dest += slask;
	dest += "<EVENT_NAME>" + q.GetDatabase().xmlsafestr(this -> event_name) + "</EVENT_NAME>";
	sprintf(slask,"<COUNT>%ld</COUNT>",this -> count);
	dest += slask;
	dest += "</EVENTCOUNT>";
	return dest;
}


std::string Eventcount::xml(const std::string& tag,const std::string& xvalx)
{
	Query q(*database);
	std::string dest;
	char slask[200];
	dest = "<EVENTCOUNT " + tag + "=\"" + xvalx + "\">";
	sprintf(slask,"<NUM>%ld</NUM>",this -> num);
	dest += slask;
	dest += "<EVENT_NAME>" + q.GetDatabase().xmlsafestr(this -> event_name) + "</EVENT_NAME>";
	sprintf(slask,"<COUNT>%ld</COUNT>",this -> count);
	dest += slask;
	dest += "</EVENTCOUNT>";
	return dest;
}


size_t Eventcount::num_cols()
{
	return 3;
}


void Eventcount::clear()
{
	this -> num = 0;
	this -> event_name = "";
	this -> count = 0;
}


void Eventcount::spawn(const std::string& sql)
{
	Query q(*database);
	std::string temp;

	clear();

	if (!strncasecmp(sql.c_str(),"select * ",9))
	{
		temp = "select num,event_name,count " + sql.substr(9);
	} else
		temp = sql;
	q.get_result(temp);
	if (q.fetch_row())
	{
		this -> num = q.getval(0);																				// 0 - num integer
		this -> event_name = q.getstr(1);																				// 1 - event_name varchar(255)
		this -> count = q.getval(2);																				// 2 - count integer
		new_object = 0;
	} else
		clear();
	q.free_result();
}


void Eventcount::spawn(Query *qd,int offset)
{
	clear();

	this -> num = qd -> getval(0 + offset);																				// 0 - num integer
	this -> event_name = qd -> getstr(1 + offset);																				// 1 - event_name varchar(255)
	this -> count = qd -> getval(2 + offset);																				// 2 - count integer
}


// End of implementation of class 'Eventcount'

} // End of namespace
namespace db {

/**
 **  Begin class 'Area'
 **/

Area::Area(Database *db)
{
	database = db;
	new_object = 1;
	clear();
}


Area::Area(Database *db,const std::string& sql)
{
	database = db;
	new_object = 1;
	spawn(sql);
}


Area::Area(Database *db,Query *qd,int offset)
{
	database = db;
	new_object = 0;
	spawn(qd, offset);
}


Area::Area(Database& db,long i_num):database(&db),new_object(1)
{
	Query q(*database);
	std::string sql = "select * from area where ";
	{
		char slask[100];
		sprintf(slask,"num='%ld'",i_num);
		sql += slask;
	}
	spawn(sql);
}


Area::Area(Database& db,const std::string&  i_name):database(&db),new_object(1)
{
	Query q(*database);
	std::string sql = "select * from area where ";
	sql += "name='" + q.GetDatabase().safestr(i_name) + "'";
	spawn(sql);
}


Area::~Area()
{
}


void Area::select(const std::string& sql)
{
	spawn(sql);
}


unsigned long long int Area::insert()
{
	Query q(*database);
	std::string sql;

	sql = "insert into area(name,width,height)";
	sql += " values('" + q.GetDatabase().safestr(this -> name) + "'";
	{
		char slask[100];
		sprintf(slask,", %ld",this -> width);
		sql += slask;
	}
	{
		char slask[100];
		sprintf(slask,", %ld",this -> height);
		sql += slask;
	}
	sql += ")";
	q.execute(sql);
	new_object = 0;
	unsigned long long int inserted_id = q.insert_id();
	num = inserted_id;
	return inserted_id;
}


void Area::update()
{
	update(this -> num);
}


void Area::update(long i_num)
{
	Query q(*database);
	std::string sql;
	sql += "update area set name='" + q.GetDatabase().safestr(this -> name) + "'";
	{
		char slask[200];
		sprintf(slask,", width=%ld",this -> width);
		sql += slask;
	}
	{
		char slask[200];
		sprintf(slask,", height=%ld",this -> height);
		sql += slask;
	}
	{
		char slask[200];
		sprintf(slask," where num='%ld'",i_num);
		sql += slask;
	}
	q.execute(sql);
}


void Area::save()
{
	if (new_object)
		insert();
	else
		update();
}


void Area::erase()
{
	if (!new_object)
	{
		std::string sql = "delete from area where";
		Query q(*database);
		{
			char slask[200];
			sprintf(slask," num='%ld'",this -> num);
			sql += slask;
		}
		q.execute(sql);
	}
}


std::string Area::xml()
{
	Query q(*database);
	std::string dest;
	char slask[200];
	dest = "<AREA>";
	sprintf(slask,"<NUM>%ld</NUM>",this -> num);
	dest += slask;
	dest += "<NAME>" + q.GetDatabase().xmlsafestr(this -> name) + "</NAME>";
	sprintf(slask,"<WIDTH>%ld</WIDTH>",this -> width);
	dest += slask;
	sprintf(slask,"<HEIGHT>%ld</HEIGHT>",this -> height);
	dest += slask;
	dest += "</AREA>";
	return dest;
}


std::string Area::xml(const std::string& tag,const std::string& xvalx)
{
	Query q(*database);
	std::string dest;
	char slask[200];
	dest = "<AREA " + tag + "=\"" + xvalx + "\">";
	sprintf(slask,"<NUM>%ld</NUM>",this -> num);
	dest += slask;
	dest += "<NAME>" + q.GetDatabase().xmlsafestr(this -> name) + "</NAME>";
	sprintf(slask,"<WIDTH>%ld</WIDTH>",this -> width);
	dest += slask;
	sprintf(slask,"<HEIGHT>%ld</HEIGHT>",this -> height);
	dest += slask;
	dest += "</AREA>";
	return dest;
}


size_t Area::num_cols()
{
	return 4;
}


void Area::clear()
{
	this -> num = 0;
	this -> name = "";
	this -> width = 0;
	this -> height = 0;
}


void Area::spawn(const std::string& sql)
{
	Query q(*database);
	std::string temp;

	clear();

	if (!strncasecmp(sql.c_str(),"select * ",9))
	{
		temp = "select num,name,width,height " + sql.substr(9);
	} else
		temp = sql;
	q.get_result(temp);
	if (q.fetch_row())
	{
		this -> num = q.getval(0);																				// 0 - num integer
		this -> name = q.getstr(1);																				// 1 - name varchar(255)
		this -> width = q.getval(2);																				// 2 - width integer
		this -> height = q.getval(3);																				// 3 - height integer
		new_object = 0;
	} else
		clear();
	q.free_result();
}


void Area::spawn(Query *qd,int offset)
{
	clear();

	this -> num = qd -> getval(0 + offset);																				// 0 - num integer
	this -> name = qd -> getstr(1 + offset);																				// 1 - name varchar(255)
	this -> width = qd -> getval(2 + offset);																				// 2 - width integer
	this -> height = qd -> getval(3 + offset);																				// 3 - height integer
}


// End of implementation of class 'Area'

} // End of namespace
namespace db {

/**
 **  Begin class 'Chunk'
 **/

Chunk::Chunk(Database *db)
{
	database = db;
	new_object = 1;
	clear();
}


Chunk::Chunk(Database *db,const std::string& sql)
{
	database = db;
	new_object = 1;
	spawn(sql);
}


Chunk::Chunk(Database *db,Query *qd,int offset)
{
	database = db;
	new_object = 0;
	spawn(qd, offset);
}


Chunk::Chunk(Database& db,long i_num):database(&db),new_object(1)
{
	Query q(*database);
	std::string sql = "select * from chunk where ";
	{
		char slask[100];
		sprintf(slask,"num='%ld'",i_num);
		sql += slask;
	}
	spawn(sql);
}


Chunk::Chunk(Database& db,long i_area,long i_x,long i_y,long i_z):database(&db),new_object(1)
{
	Query q(*database);
	std::string sql = "select * from chunk where ";
	{
		char slask[100];
		sprintf(slask,"area='%ld'",i_area);
		sql += slask;
	}
	{
		char slask[100];
		sprintf(slask," and x='%ld'",i_x);
		sql += slask;
	}
	{
		char slask[100];
		sprintf(slask," and y='%ld'",i_y);
		sql += slask;
	}
	{
		char slask[100];
		sprintf(slask," and z='%ld'",i_z);
		sql += slask;
	}
	spawn(sql);
}


Chunk::~Chunk()
{
}


void Chunk::select(const std::string& sql)
{
	spawn(sql);
}


unsigned long long int Chunk::insert()
{
	Query q(*database);
	std::string sql;

	sql = "insert into chunk(area,terrain,x,y,z,created_by,created_date)";
	{
		char slask[100];
		sprintf(slask," values(%ld",this -> area);
		sql += slask;
	}
	sql += ", '" + q.GetDatabase().safestr(this -> terrain) + "'";
	{
		char slask[100];
		sprintf(slask,", %ld",this -> x);
		sql += slask;
	}
	{
		char slask[100];
		sprintf(slask,", %ld",this -> y);
		sql += slask;
	}
	{
		char slask[100];
		sprintf(slask,", %ld",this -> z);
		sql += slask;
	}
	{
		char slask[100];
		sprintf(slask,", %ld",this -> created_by);
		sql += slask;
	}
	sql += ", '" + q.GetDatabase().safestr(this -> created_date) + "'";
	sql += ")";
	q.execute(sql);
	new_object = 0;
	unsigned long long int inserted_id = q.insert_id();
	num = inserted_id;
	return inserted_id;
}


void Chunk::update()
{
	update(this -> num);
}


void Chunk::update(long i_num)
{
	Query q(*database);
	std::string sql;
	{
		char slask[200];
		sprintf(slask,"update chunk set area=%ld",this -> area);
		sql += slask;
	}
	sql += ", terrain='" + q.GetDatabase().safestr(this -> terrain) + "'";
	{
		char slask[200];
		sprintf(slask,", x=%ld",this -> x);
		sql += slask;
	}
	{
		char slask[200];
		sprintf(slask,", y=%ld",this -> y);
		sql += slask;
	}
	{
		char slask[200];
		sprintf(slask,", z=%ld",this -> z);
		sql += slask;
	}
	{
		char slask[200];
		sprintf(slask,", created_by=%ld",this -> created_by);
		sql += slask;
	}
	sql += ", created_date='" + q.GetDatabase().safestr(this -> created_date) + "'";
	{
		char slask[200];
		sprintf(slask," where num='%ld'",i_num);
		sql += slask;
	}
	q.execute(sql);
}


void Chunk::save()
{
	if (new_object)
		insert();
	else
		update();
}


void Chunk::erase()
{
	if (!new_object)
	{
		std::string sql = "delete from chunk where";
		Query q(*database);
		{
			char slask[200];
			sprintf(slask," num='%ld'",this -> num);
			sql += slask;
		}
		q.execute(sql);
	}
}


std::string Chunk::xml()
{
	Query q(*database);
	std::string dest;
	char slask[200];
	dest = "<CHUNK>";
	sprintf(slask,"<NUM>%ld</NUM>",this -> num);
	dest += slask;
	sprintf(slask,"<AREA>%ld</AREA>",this -> area);
	dest += slask;
	dest += "<TERRAIN>" + q.GetDatabase().xmlsafestr(this -> terrain) + "</TERRAIN>";
	sprintf(slask,"<X>%ld</X>",this -> x);
	dest += slask;
	sprintf(slask,"<Y>%ld</Y>",this -> y);
	dest += slask;
	sprintf(slask,"<Z>%ld</Z>",this -> z);
	dest += slask;
	sprintf(slask,"<CREATED_BY>%ld</CREATED_BY>",this -> created_by);
	dest += slask;
	dest += "<CREATED_DATE>" + q.GetDatabase().xmlsafestr(this -> created_date) + "</CREATED_DATE>";
	dest += "</CHUNK>";
	return dest;
}


std::string Chunk::xml(const std::string& tag,const std::string& xvalx)
{
	Query q(*database);
	std::string dest;
	char slask[200];
	dest = "<CHUNK " + tag + "=\"" + xvalx + "\">";
	sprintf(slask,"<NUM>%ld</NUM>",this -> num);
	dest += slask;
	sprintf(slask,"<AREA>%ld</AREA>",this -> area);
	dest += slask;
	dest += "<TERRAIN>" + q.GetDatabase().xmlsafestr(this -> terrain) + "</TERRAIN>";
	sprintf(slask,"<X>%ld</X>",this -> x);
	dest += slask;
	sprintf(slask,"<Y>%ld</Y>",this -> y);
	dest += slask;
	sprintf(slask,"<Z>%ld</Z>",this -> z);
	dest += slask;
	sprintf(slask,"<CREATED_BY>%ld</CREATED_BY>",this -> created_by);
	dest += slask;
	dest += "<CREATED_DATE>" + q.GetDatabase().xmlsafestr(this -> created_date) + "</CREATED_DATE>";
	dest += "</CHUNK>";
	return dest;
}


size_t Chunk::num_cols()
{
	return 8;
}


void Chunk::clear()
{
	this -> num = 0;
	this -> area = 0;
	this -> terrain = "";
	this -> x = 0;
	this -> y = 0;
	this -> z = 0;
	this -> created_by = 0;
	this -> created_date = "";
}


void Chunk::spawn(const std::string& sql)
{
	Query q(*database);
	std::string temp;

	clear();

	if (!strncasecmp(sql.c_str(),"select * ",9))
	{
		temp = "select num,area,terrain,x,y,z,created_by,created_date " + sql.substr(9);
	} else
		temp = sql;
	q.get_result(temp);
	if (q.fetch_row())
	{
		this -> num = q.getval(0);																				// 0 - num integer
		this -> area = q.getval(1);																				// 1 - area integer
		this -> terrain = q.getstr(2);																				// 2 - terrain text
		this -> x = q.getval(3);																				// 3 - x integer
		this -> y = q.getval(4);																				// 4 - y integer
		this -> z = q.getval(5);																				// 5 - z integer
		this -> created_by = q.getval(6);																				// 6 - created_by integer
		this -> created_date = q.getstr(7);																				// 7 - created_date datetime
		new_object = 0;
	} else
		clear();
	q.free_result();
}


void Chunk::spawn(Query *qd,int offset)
{
	clear();

	this -> num = qd -> getval(0 + offset);																				// 0 - num integer
	this -> area = qd -> getval(1 + offset);																				// 1 - area integer
	this -> terrain = qd -> getstr(2 + offset);																				// 2 - terrain text
	this -> x = qd -> getval(3 + offset);																				// 3 - x integer
	this -> y = qd -> getval(4 + offset);																				// 4 - y integer
	this -> z = qd -> getval(5 + offset);																				// 5 - z integer
	this -> created_by = qd -> getval(6 + offset);																				// 6 - created_by integer
	this -> created_date = qd -> getstr(7 + offset);																				// 7 - created_date datetime
}


// End of implementation of class 'Chunk'

} // End of namespace
namespace db {

/**
 **  Begin class 'Chunkinfo'
 **/

Chunkinfo::Chunkinfo(Database *db)
{
	database = db;
	new_object = 1;
	clear();
}


Chunkinfo::Chunkinfo(Database *db,const std::string& sql)
{
	database = db;
	new_object = 1;
	spawn(sql);
}


Chunkinfo::Chunkinfo(Database *db,Query *qd,int offset)
{
	database = db;
	new_object = 0;
	spawn(qd, offset);
}


Chunkinfo::Chunkinfo(Database& db,long i_num):database(&db),new_object(1)
{
	Query q(*database);
	std::string sql = "select * from chunkinfo where ";
	{
		char slask[100];
		sprintf(slask,"num='%ld'",i_num);
		sql += slask;
	}
	spawn(sql);
}


Chunkinfo::Chunkinfo(Database& db,long i_chunk,long i_type,long i_x,long i_y):database(&db),new_object(1)
{
	Query q(*database);
	std::string sql = "select * from chunkinfo where ";
	{
		char slask[100];
		sprintf(slask,"chunk='%ld'",i_chunk);
		sql += slask;
	}
	{
		char slask[100];
		sprintf(slask," and type='%ld'",i_type);
		sql += slask;
	}
	{
		char slask[100];
		sprintf(slask," and x='%ld'",i_x);
		sql += slask;
	}
	{
		char slask[100];
		sprintf(slask," and y='%ld'",i_y);
		sql += slask;
	}
	spawn(sql);
}


Chunkinfo::~Chunkinfo()
{
}


void Chunkinfo::select(const std::string& sql)
{
	spawn(sql);
}


unsigned long long int Chunkinfo::insert()
{
	Query q(*database);
	std::string sql;

	sql = "insert into chunkinfo(chunk,type,x,y,data,to_area,to_chunk,to_x,to_y)";
	{
		char slask[100];
		sprintf(slask," values(%ld",this -> chunk);
		sql += slask;
	}
	{
		char slask[100];
		sprintf(slask,", %ld",this -> type);
		sql += slask;
	}
	{
		char slask[100];
		sprintf(slask,", %ld",this -> x);
		sql += slask;
	}
	{
		char slask[100];
		sprintf(slask,", %ld",this -> y);
		sql += slask;
	}
	sql += ", '" + q.GetDatabase().safestr(this -> data) + "'";
	{
		char slask[100];
		sprintf(slask,", %ld",this -> to_area);
		sql += slask;
	}
	{
		char slask[100];
		sprintf(slask,", %ld",this -> to_chunk);
		sql += slask;
	}
	{
		char slask[100];
		sprintf(slask,", %ld",this -> to_x);
		sql += slask;
	}
	{
		char slask[100];
		sprintf(slask,", %ld",this -> to_y);
		sql += slask;
	}
	sql += ")";
	q.execute(sql);
	new_object = 0;
	unsigned long long int inserted_id = q.insert_id();
	num = inserted_id;
	return inserted_id;
}


void Chunkinfo::update()
{
	update(this -> num);
}


void Chunkinfo::update(long i_num)
{
	Query q(*database);
	std::string sql;
	{
		char slask[200];
		sprintf(slask,"update chunkinfo set chunk=%ld",this -> chunk);
		sql += slask;
	}
	{
		char slask[200];
		sprintf(slask,", type=%ld",this -> type);
		sql += slask;
	}
	{
		char slask[200];
		sprintf(slask,", x=%ld",this -> x);
		sql += slask;
	}
	{
		char slask[200];
		sprintf(slask,", y=%ld",this -> y);
		sql += slask;
	}
	sql += ", data='" + q.GetDatabase().safestr(this -> data) + "'";
	{
		char slask[200];
		sprintf(slask,", to_area=%ld",this -> to_area);
		sql += slask;
	}
	{
		char slask[200];
		sprintf(slask,", to_chunk=%ld",this -> to_chunk);
		sql += slask;
	}
	{
		char slask[200];
		sprintf(slask,", to_x=%ld",this -> to_x);
		sql += slask;
	}
	{
		char slask[200];
		sprintf(slask,", to_y=%ld",this -> to_y);
		sql += slask;
	}
	{
		char slask[200];
		sprintf(slask," where num='%ld'",i_num);
		sql += slask;
	}
	q.execute(sql);
}


void Chunkinfo::save()
{
	if (new_object)
		insert();
	else
		update();
}


void Chunkinfo::erase()
{
	if (!new_object)
	{
		std::string sql = "delete from chunkinfo where";
		Query q(*database);
		{
			char slask[200];
			sprintf(slask," num='%ld'",this -> num);
			sql += slask;
		}
		q.execute(sql);
	}
}


std::string Chunkinfo::xml()
{
	Query q(*database);
	std::string dest;
	char slask[200];
	dest = "<CHUNKINFO>";
	sprintf(slask,"<NUM>%ld</NUM>",this -> num);
	dest += slask;
	sprintf(slask,"<CHUNK>%ld</CHUNK>",this -> chunk);
	dest += slask;
	sprintf(slask,"<TYPE>%ld</TYPE>",this -> type);
	dest += slask;
	sprintf(slask,"<X>%ld</X>",this -> x);
	dest += slask;
	sprintf(slask,"<Y>%ld</Y>",this -> y);
	dest += slask;
	dest += "<DATA>" + q.GetDatabase().xmlsafestr(this -> data) + "</DATA>";
	sprintf(slask,"<TO_AREA>%ld</TO_AREA>",this -> to_area);
	dest += slask;
	sprintf(slask,"<TO_CHUNK>%ld</TO_CHUNK>",this -> to_chunk);
	dest += slask;
	sprintf(slask,"<TO_X>%ld</TO_X>",this -> to_x);
	dest += slask;
	sprintf(slask,"<TO_Y>%ld</TO_Y>",this -> to_y);
	dest += slask;
	dest += "</CHUNKINFO>";
	return dest;
}


std::string Chunkinfo::xml(const std::string& tag,const std::string& xvalx)
{
	Query q(*database);
	std::string dest;
	char slask[200];
	dest = "<CHUNKINFO " + tag + "=\"" + xvalx + "\">";
	sprintf(slask,"<NUM>%ld</NUM>",this -> num);
	dest += slask;
	sprintf(slask,"<CHUNK>%ld</CHUNK>",this -> chunk);
	dest += slask;
	sprintf(slask,"<TYPE>%ld</TYPE>",this -> type);
	dest += slask;
	sprintf(slask,"<X>%ld</X>",this -> x);
	dest += slask;
	sprintf(slask,"<Y>%ld</Y>",this -> y);
	dest += slask;
	dest += "<DATA>" + q.GetDatabase().xmlsafestr(this -> data) + "</DATA>";
	sprintf(slask,"<TO_AREA>%ld</TO_AREA>",this -> to_area);
	dest += slask;
	sprintf(slask,"<TO_CHUNK>%ld</TO_CHUNK>",this -> to_chunk);
	dest += slask;
	sprintf(slask,"<TO_X>%ld</TO_X>",this -> to_x);
	dest += slask;
	sprintf(slask,"<TO_Y>%ld</TO_Y>",this -> to_y);
	dest += slask;
	dest += "</CHUNKINFO>";
	return dest;
}


size_t Chunkinfo::num_cols()
{
	return 10;
}


void Chunkinfo::clear()
{
	this -> num = 0;
	this -> chunk = 0;
	this -> type = 0;
	this -> x = 0;
	this -> y = 0;
	this -> data = "";
	this -> to_area = 0;
	this -> to_chunk = 0;
	this -> to_x = 0;
	this -> to_y = 0;
}


void Chunkinfo::spawn(const std::string& sql)
{
	Query q(*database);
	std::string temp;

	clear();

	if (!strncasecmp(sql.c_str(),"select * ",9))
	{
		temp = "select num,chunk,type,x,y,data,to_area,to_chunk,to_x,to_y " + sql.substr(9);
	} else
		temp = sql;
	q.get_result(temp);
	if (q.fetch_row())
	{
		this -> num = q.getval(0);																				// 0 - num integer
		this -> chunk = q.getval(1);																				// 1 - chunk integer
		this -> type = q.getval(2);																				// 2 - type integer
		this -> x = q.getval(3);																				// 3 - x integer
		this -> y = q.getval(4);																				// 4 - y integer
		this -> data = q.getstr(5);																				// 5 - data varchar(255)
		this -> to_area = q.getval(6);																				// 6 - to_area integer
		this -> to_chunk = q.getval(7);																				// 7 - to_chunk integer
		this -> to_x = q.getval(8);																				// 8 - to_x integer
		this -> to_y = q.getval(9);																				// 9 - to_y integer
		new_object = 0;
	} else
		clear();
	q.free_result();
}


void Chunkinfo::spawn(Query *qd,int offset)
{
	clear();

	this -> num = qd -> getval(0 + offset);																				// 0 - num integer
	this -> chunk = qd -> getval(1 + offset);																				// 1 - chunk integer
	this -> type = qd -> getval(2 + offset);																				// 2 - type integer
	this -> x = qd -> getval(3 + offset);																				// 3 - x integer
	this -> y = qd -> getval(4 + offset);																				// 4 - y integer
	this -> data = qd -> getstr(5 + offset);																				// 5 - data varchar(255)
	this -> to_area = qd -> getval(6 + offset);																				// 6 - to_area integer
	this -> to_chunk = qd -> getval(7 + offset);																				// 7 - to_chunk integer
	this -> to_x = qd -> getval(8 + offset);																				// 8 - to_x integer
	this -> to_y = qd -> getval(9 + offset);																				// 9 - to_y integer
}


// End of implementation of class 'Chunkinfo'

} // End of namespace
namespace db {

/**
 **  Begin class 'Terrain'
 **/

Terrain::Terrain(Database *db)
{
	database = db;
	new_object = 1;
	clear();
}


Terrain::Terrain(Database *db,const std::string& sql)
{
	database = db;
	new_object = 1;
	spawn(sql);
}


Terrain::Terrain(Database *db,Query *qd,int offset)
{
	database = db;
	new_object = 0;
	spawn(qd, offset);
}


Terrain::Terrain(Database& db,long i_num):database(&db),new_object(1)
{
	Query q(*database);
	std::string sql = "select * from terrain where ";
	{
		char slask[100];
		sprintf(slask,"num='%ld'",i_num);
		sql += slask;
	}
	spawn(sql);
}


Terrain::Terrain(Database& db,long i_area,const std::string&  i_tchar):database(&db),new_object(1)
{
	Query q(*database);
	std::string sql = "select * from terrain where ";
	{
		char slask[100];
		sprintf(slask,"area='%ld'",i_area);
		sql += slask;
	}
	sql += " and tchar='" + q.GetDatabase().safestr(i_tchar) + "'";
	spawn(sql);
}


Terrain::~Terrain()
{
}


void Terrain::select(const std::string& sql)
{
	spawn(sql);
}


unsigned long long int Terrain::insert()
{
	Query q(*database);
	std::string sql;

	sql = "insert into terrain(area,name,tchar,tcolor,impassable,delay)";
	{
		char slask[100];
		sprintf(slask," values(%ld",this -> area);
		sql += slask;
	}
	sql += ", '" + q.GetDatabase().safestr(this -> name) + "'";
	sql += ", '" + q.GetDatabase().safestr(this -> tchar) + "'";
	sql += ", '" + q.GetDatabase().safestr(this -> tcolor) + "'";
	{
		char slask[100];
		sprintf(slask,", %ld",this -> impassable);
		sql += slask;
	}
	{
		char slask[100];
		sprintf(slask,", %f",this -> delay);
		sql += slask;
	}
	sql += ")";
	q.execute(sql);
	new_object = 0;
	unsigned long long int inserted_id = q.insert_id();
	num = inserted_id;
	return inserted_id;
}


void Terrain::update()
{
	update(this -> num);
}


void Terrain::update(long i_num)
{
	Query q(*database);
	std::string sql;
	{
		char slask[200];
		sprintf(slask,"update terrain set area=%ld",this -> area);
		sql += slask;
	}
	sql += ", name='" + q.GetDatabase().safestr(this -> name) + "'";
	sql += ", tchar='" + q.GetDatabase().safestr(this -> tchar) + "'";
	sql += ", tcolor='" + q.GetDatabase().safestr(this -> tcolor) + "'";
	{
		char slask[200];
		sprintf(slask,", impassable=%ld",this -> impassable);
		sql += slask;
	}
	{
		char slask[200];
		sprintf(slask,", delay='%f'",this -> delay);
		sql += slask;
	}
	{
		char slask[200];
		sprintf(slask," where num='%ld'",i_num);
		sql += slask;
	}
	q.execute(sql);
}


void Terrain::save()
{
	if (new_object)
		insert();
	else
		update();
}


void Terrain::erase()
{
	if (!new_object)
	{
		std::string sql = "delete from terrain where";
		Query q(*database);
		{
			char slask[200];
			sprintf(slask," num='%ld'",this -> num);
			sql += slask;
		}
		q.execute(sql);
	}
}


std::string Terrain::xml()
{
	Query q(*database);
	std::string dest;
	char slask[200];
	dest = "<TERRAIN>";
	sprintf(slask,"<NUM>%ld</NUM>",this -> num);
	dest += slask;
	sprintf(slask,"<AREA>%ld</AREA>",this -> area);
	dest += slask;
	dest += "<NAME>" + q.GetDatabase().xmlsafestr(this -> name) + "</NAME>";
	dest += "<TCHAR>" + q.GetDatabase().xmlsafestr(this -> tchar) + "</TCHAR>";
	dest += "<TCOLOR>" + q.GetDatabase().xmlsafestr(this -> tcolor) + "</TCOLOR>";
	sprintf(slask,"<IMPASSABLE>%ld</IMPASSABLE>",this -> impassable);
	dest += slask;
	sprintf(slask,"<DELAY>%f</DELAY>",this -> delay);
	dest += slask;
	dest += "</TERRAIN>";
	return dest;
}


std::string Terrain::xml(const std::string& tag,const std::string& xvalx)
{
	Query q(*database);
	std::string dest;
	char slask[200];
	dest = "<TERRAIN " + tag + "=\"" + xvalx + "\">";
	sprintf(slask,"<NUM>%ld</NUM>",this -> num);
	dest += slask;
	sprintf(slask,"<AREA>%ld</AREA>",this -> area);
	dest += slask;
	dest += "<NAME>" + q.GetDatabase().xmlsafestr(this -> name) + "</NAME>";
	dest += "<TCHAR>" + q.GetDatabase().xmlsafestr(this -> tchar) + "</TCHAR>";
	dest += "<TCOLOR>" + q.GetDatabase().xmlsafestr(this -> tcolor) + "</TCOLOR>";
	sprintf(slask,"<IMPASSABLE>%ld</IMPASSABLE>",this -> impassable);
	dest += slask;
	sprintf(slask,"<DELAY>%f</DELAY>",this -> delay);
	dest += slask;
	dest += "</TERRAIN>";
	return dest;
}


size_t Terrain::num_cols()
{
	return 7;
}


void Terrain::clear()
{
	this -> num = 0;
	this -> area = 0;
	this -> name = "";
	this -> tchar = "";
	this -> tcolor = "";
	this -> impassable = 0;
	this -> delay = 0;
}


void Terrain::spawn(const std::string& sql)
{
	Query q(*database);
	std::string temp;

	clear();

	if (!strncasecmp(sql.c_str(),"select * ",9))
	{
		temp = "select num,area,name,tchar,tcolor,impassable,delay " + sql.substr(9);
	} else
		temp = sql;
	q.get_result(temp);
	if (q.fetch_row())
	{
		this -> num = q.getval(0);																				// 0 - num integer
		this -> area = q.getval(1);																				// 1 - area integer
		this -> name = q.getstr(2);																				// 2 - name varchar(255)
		this -> tchar = q.getstr(3);																				// 3 - tchar char(1)
		this -> tcolor = q.getstr(4);																				// 4 - tcolor varchar(10)
		this -> impassable = q.getval(5);																				// 5 - impassable integer
		this -> delay = q.getnum(6);																				// 6 - delay float
		new_object = 0;
	} else
		clear();
	q.free_result();
}


void Terrain::spawn(Query *qd,int offset)
{
	clear();

	this -> num = qd -> getval(0 + offset);																				// 0 - num integer
	this -> area = qd -> getval(1 + offset);																				// 1 - area integer
	this -> name = qd -> getstr(2 + offset);																				// 2 - name varchar(255)
	this -> tchar = qd -> getstr(3 + offset);																				// 3 - tchar char(1)
	this -> tcolor = qd -> getstr(4 + offset);																				// 4 - tcolor varchar(10)
	this -> impassable = qd -> getval(5 + offset);																				// 5 - impassable integer
	this -> delay = qd -> getnum(6 + offset);																				// 6 - delay float
}


// End of implementation of class 'Terrain'

} // End of namespace
namespace db {

/**
 **  Begin class 'Steps'
 **/

Steps::Steps(Database *db)
{
	database = db;
	new_object = 1;
	clear();
}


Steps::Steps(Database *db,const std::string& sql)
{
	database = db;
	new_object = 1;
	spawn(sql);
}


Steps::Steps(Database *db,Query *qd,int offset)
{
	database = db;
	new_object = 0;
	spawn(qd, offset);
}


Steps::Steps(Database& db,long i_num):database(&db),new_object(1)
{
	Query q(*database);
	std::string sql = "select * from steps where ";
	{
		char slask[100];
		sprintf(slask,"num='%ld'",i_num);
		sql += slask;
	}
	spawn(sql);
}


Steps::Steps(Database& db,long i_player,long i_area,long i_zcoord,long i_ycoord):database(&db),new_object(1)
{
	Query q(*database);
	std::string sql = "select * from steps where ";
	{
		char slask[100];
		sprintf(slask,"player='%ld'",i_player);
		sql += slask;
	}
	{
		char slask[100];
		sprintf(slask," and area='%ld'",i_area);
		sql += slask;
	}
	{
		char slask[100];
		sprintf(slask," and zcoord='%ld'",i_zcoord);
		sql += slask;
	}
	{
		char slask[100];
		sprintf(slask," and ycoord='%ld'",i_ycoord);
		sql += slask;
	}
	spawn(sql);
}


Steps::~Steps()
{
}


void Steps::select(const std::string& sql)
{
	spawn(sql);
}


unsigned long long int Steps::insert()
{
	Query q(*database);
	std::string sql;

	sql = "insert into steps(player,area,zcoord,ycoord,xcoords)";
	{
		char slask[100];
		sprintf(slask," values(%ld",this -> player);
		sql += slask;
	}
	{
		char slask[100];
		sprintf(slask,", %ld",this -> area);
		sql += slask;
	}
	{
		char slask[100];
		sprintf(slask,", %ld",this -> zcoord);
		sql += slask;
	}
	{
		char slask[100];
		sprintf(slask,", %ld",this -> ycoord);
		sql += slask;
	}
	sql += ", '" + q.GetDatabase().safestr(this -> xcoords) + "'";
	sql += ")";
	q.execute(sql);
	new_object = 0;
	unsigned long long int inserted_id = q.insert_id();
	num = inserted_id;
	return inserted_id;
}


void Steps::update()
{
	update(this -> num);
}


void Steps::update(long i_num)
{
	Query q(*database);
	std::string sql;
	{
		char slask[200];
		sprintf(slask,"update steps set player=%ld",this -> player);
		sql += slask;
	}
	{
		char slask[200];
		sprintf(slask,", area=%ld",this -> area);
		sql += slask;
	}
	{
		char slask[200];
		sprintf(slask,", zcoord=%ld",this -> zcoord);
		sql += slask;
	}
	{
		char slask[200];
		sprintf(slask,", ycoord=%ld",this -> ycoord);
		sql += slask;
	}
	sql += ", xcoords='" + q.GetDatabase().safestr(this -> xcoords) + "'";
	{
		char slask[200];
		sprintf(slask," where num='%ld'",i_num);
		sql += slask;
	}
	q.execute(sql);
}


void Steps::save()
{
	if (new_object)
		insert();
	else
		update();
}


void Steps::erase()
{
	if (!new_object)
	{
		std::string sql = "delete from steps where";
		Query q(*database);
		{
			char slask[200];
			sprintf(slask," num='%ld'",this -> num);
			sql += slask;
		}
		q.execute(sql);
	}
}


std::string Steps::xml()
{
	Query q(*database);
	std::string dest;
	char slask[200];
	dest = "<STEPS>";
	sprintf(slask,"<NUM>%ld</NUM>",this -> num);
	dest += slask;
	sprintf(slask,"<PLAYER>%ld</PLAYER>",this -> player);
	dest += slask;
	sprintf(slask,"<AREA>%ld</AREA>",this -> area);
	dest += slask;
	sprintf(slask,"<ZCOORD>%ld</ZCOORD>",this -> zcoord);
	dest += slask;
	sprintf(slask,"<YCOORD>%ld</YCOORD>",this -> ycoord);
	dest += slask;
	dest += "<XCOORDS>" + q.GetDatabase().xmlsafestr(this -> xcoords) + "</XCOORDS>";
	dest += "</STEPS>";
	return dest;
}


std::string Steps::xml(const std::string& tag,const std::string& xvalx)
{
	Query q(*database);
	std::string dest;
	char slask[200];
	dest = "<STEPS " + tag + "=\"" + xvalx + "\">";
	sprintf(slask,"<NUM>%ld</NUM>",this -> num);
	dest += slask;
	sprintf(slask,"<PLAYER>%ld</PLAYER>",this -> player);
	dest += slask;
	sprintf(slask,"<AREA>%ld</AREA>",this -> area);
	dest += slask;
	sprintf(slask,"<ZCOORD>%ld</ZCOORD>",this -> zcoord);
	dest += slask;
	sprintf(slask,"<YCOORD>%ld</YCOORD>",this -> ycoord);
	dest += slask;
	dest += "<XCOORDS>" + q.GetDatabase().xmlsafestr(this -> xcoords) + "</XCOORDS>";
	dest += "</STEPS>";
	return dest;
}


size_t Steps::num_cols()
{
	return 6;
}


void Steps::clear()
{
	this -> num = 0;
	this -> player = 0;
	this -> area = 0;
	this -> zcoord = 0;
	this -> ycoord = 0;
	this -> xcoords = "";
}


void Steps::spawn(const std::string& sql)
{
	Query q(*database);
	std::string temp;

	clear();

	if (!strncasecmp(sql.c_str(),"select * ",9))
	{
		temp = "select num,player,area,zcoord,ycoord,xcoords " + sql.substr(9);
	} else
		temp = sql;
	q.get_result(temp);
	if (q.fetch_row())
	{
		this -> num = q.getval(0);																				// 0 - num integer
		this -> player = q.getval(1);																				// 1 - player integer
		this -> area = q.getval(2);																				// 2 - area integer
		this -> zcoord = q.getval(3);																				// 3 - zcoord integer
		this -> ycoord = q.getval(4);																				// 4 - ycoord integer
		this -> xcoords = q.getstr(5);																				// 5 - xcoords text
		new_object = 0;
	} else
		clear();
	q.free_result();
}


void Steps::spawn(Query *qd,int offset)
{
	clear();

	this -> num = qd -> getval(0 + offset);																				// 0 - num integer
	this -> player = qd -> getval(1 + offset);																				// 1 - player integer
	this -> area = qd -> getval(2 + offset);																				// 2 - area integer
	this -> zcoord = qd -> getval(3 + offset);																				// 3 - zcoord integer
	this -> ycoord = qd -> getval(4 + offset);																				// 4 - ycoord integer
	this -> xcoords = qd -> getstr(5 + offset);																				// 5 - xcoords text
}


// End of implementation of class 'Steps'

} // End of namespace
namespace db {

/**
 **  Begin class 'Race'
 **/

Race::Race(Database *db)
{
	database = db;
	new_object = 1;
	clear();
}


Race::Race(Database *db,const std::string& sql)
{
	database = db;
	new_object = 1;
	spawn(sql);
}


Race::Race(Database *db,Query *qd,int offset)
{
	database = db;
	new_object = 0;
	spawn(qd, offset);
}


Race::Race(Database& db,long i_num):database(&db),new_object(1)
{
	Query q(*database);
	std::string sql = "select * from race where ";
	{
		char slask[100];
		sprintf(slask,"num='%ld'",i_num);
		sql += slask;
	}
	spawn(sql);
}


Race::Race(Database& db,const std::string&  i_name):database(&db),new_object(1)
{
	Query q(*database);
	std::string sql = "select * from race where ";
	sql += "name='" + q.GetDatabase().safestr(i_name) + "'";
	spawn(sql);
}


Race::~Race()
{
}


void Race::select(const std::string& sql)
{
	spawn(sql);
}


unsigned long long int Race::insert()
{
	Query q(*database);
	std::string sql;

	sql = "insert into race(name,sightrange,hearing)";
	sql += " values('" + q.GetDatabase().safestr(this -> name) + "'";
	{
		char slask[100];
		sprintf(slask,", %f",this -> sightrange);
		sql += slask;
	}
	{
		char slask[100];
		sprintf(slask,", %f",this -> hearing);
		sql += slask;
	}
	sql += ")";
	q.execute(sql);
	new_object = 0;
	unsigned long long int inserted_id = q.insert_id();
	num = inserted_id;
	return inserted_id;
}


void Race::update()
{
	update(this -> num);
}


void Race::update(long i_num)
{
	Query q(*database);
	std::string sql;
	sql += "update race set name='" + q.GetDatabase().safestr(this -> name) + "'";
	{
		char slask[200];
		sprintf(slask,", sightrange='%f'",this -> sightrange);
		sql += slask;
	}
	{
		char slask[200];
		sprintf(slask,", hearing='%f'",this -> hearing);
		sql += slask;
	}
	{
		char slask[200];
		sprintf(slask," where num='%ld'",i_num);
		sql += slask;
	}
	q.execute(sql);
}


void Race::save()
{
	if (new_object)
		insert();
	else
		update();
}


void Race::erase()
{
	if (!new_object)
	{
		std::string sql = "delete from race where";
		Query q(*database);
		{
			char slask[200];
			sprintf(slask," num='%ld'",this -> num);
			sql += slask;
		}
		q.execute(sql);
	}
}


std::string Race::xml()
{
	Query q(*database);
	std::string dest;
	char slask[200];
	dest = "<RACE>";
	sprintf(slask,"<NUM>%ld</NUM>",this -> num);
	dest += slask;
	dest += "<NAME>" + q.GetDatabase().xmlsafestr(this -> name) + "</NAME>";
	sprintf(slask,"<SIGHTRANGE>%f</SIGHTRANGE>",this -> sightrange);
	dest += slask;
	sprintf(slask,"<HEARING>%f</HEARING>",this -> hearing);
	dest += slask;
	dest += "</RACE>";
	return dest;
}


std::string Race::xml(const std::string& tag,const std::string& xvalx)
{
	Query q(*database);
	std::string dest;
	char slask[200];
	dest = "<RACE " + tag + "=\"" + xvalx + "\">";
	sprintf(slask,"<NUM>%ld</NUM>",this -> num);
	dest += slask;
	dest += "<NAME>" + q.GetDatabase().xmlsafestr(this -> name) + "</NAME>";
	sprintf(slask,"<SIGHTRANGE>%f</SIGHTRANGE>",this -> sightrange);
	dest += slask;
	sprintf(slask,"<HEARING>%f</HEARING>",this -> hearing);
	dest += slask;
	dest += "</RACE>";
	return dest;
}


size_t Race::num_cols()
{
	return 4;
}


void Race::clear()
{
	this -> num = 0;
	this -> name = "";
	this -> sightrange = 0;
	this -> hearing = 0;
}


void Race::spawn(const std::string& sql)
{
	Query q(*database);
	std::string temp;

	clear();

	if (!strncasecmp(sql.c_str(),"select * ",9))
	{
		temp = "select num,name,sightrange,hearing " + sql.substr(9);
	} else
		temp = sql;
	q.get_result(temp);
	if (q.fetch_row())
	{
		this -> num = q.getval(0);																				// 0 - num integer
		this -> name = q.getstr(1);																				// 1 - name varchar(255)
		this -> sightrange = q.getnum(2);																				// 2 - sightrange float
		this -> hearing = q.getnum(3);																				// 3 - hearing float
		new_object = 0;
	} else
		clear();
	q.free_result();
}


void Race::spawn(Query *qd,int offset)
{
	clear();

	this -> num = qd -> getval(0 + offset);																				// 0 - num integer
	this -> name = qd -> getstr(1 + offset);																				// 1 - name varchar(255)
	this -> sightrange = qd -> getnum(2 + offset);																				// 2 - sightrange float
	this -> hearing = qd -> getnum(3 + offset);																				// 3 - hearing float
}


// End of implementation of class 'Race'

} // End of namespace
